<?php
	include("config/sysconfig.php");
	include("dbconnect.php");
	include("functions.php");
	
	/*
	session_start();
	
	if ($_SESSION["user"]["pKey"]==0) {
		returnError("Nicht eingeloggt");
		exit;
	}
	*/
	
	$barcode=$_GET["gtin"];
	if (strlen($barcode)==8) { $barcode = substr($barcode, 0,7); }

	if ($barcode=='') {
		returnError("Kein Barcode.");
		exit;
	}

	// Including all required classes
	require('classes/BCGFont.php');
	require('classes/BCGColor.php');
	require('classes/BCGDrawing.php'); 

	// Including the barcode technology
	if (strlen($barcode)==13) {
		include('classes/BCGean13.barcode.php'); 
	}	elseif(strlen($barcode)==7) {
		include('classes/BCGean8.barcode.php'); 
	} else {
		returnError("Keine EAN8/13.");
		exit;
	}

	// Loading Font
	if ($_GET["noText"]!="true") {
		$font = new BCGFont('./classes/font/Arial.ttf', 12);
	}

	// The arguments are R, G, B for color.
	$color_black = new BCGColor(0, 0, 0);
	$color_white = new BCGColor(255, 255, 255);
	
	if (strlen($barcode)==13) {
		$code = new BCGean13();
	} else {
		$code = new BCGean8();
	}
	$code->setScale(2); // Resolution
	$code->setThickness(30); // Thickness
	$code->setForegroundColor($color_black); // Color of bars
	$code->setBackgroundColor($color_white); // Color of spaces
	$code->setFont($font); // Font (or 0)
	$code->parse($barcode); // Text	
	$drawing = new BCGDrawing('', $color_white);
	$drawing->setBarcode($code);
	$drawing->draw();

	// Header that says it is an image (remove it if you save the barcode to a file)
	header('Content-Type: image/png');

	// Draw (or save) the image into PNG format.
	$drawing->finish(BCGDrawing::IMG_FORMAT_PNG);
?>