<?php
	function e($nachricht) {
		global $errors;
		if (!isset($errors)) { return; }
		array_push($errors, $nachricht);
	}
	function getErrors() {
		global $errors;
		return $errors;
	}
	function s($nachricht) {
		global $status;
		if (!isset($status)) { return; }
		array_push($status, $nachricht);
	}
	
	function d($nachricht) {
		global $debug;
		if (!isset($debug)) { return; }
		if (!$debug) { return; }
		$mtime = sprintf("%5.4f", microtime_float());
		$mtime = explode(".", $mtime);
		$debugstr=date("Y-m-d H:i:s", ($mtime[0]+0)) .".". $mtime[1] ." - ". $nachricht;
		if ($debug=="console") { print $debugstr ."\n"; }
		if ($debug=="status") { s($debugstr); }
		if ($debug=="db") {
			global $debugstr;
			$debugstr .= $nachricht ."\n";
		}
	}
	
	function checkAgainstLDAP($mwnid, $password) {
		$r = ldap_connect("192.168.1.1", "389");
		if (!$r) { return 1; }
		if (ldap_bind($r, $mwnid, $password)==true) { return 0; }
		return 2;
	}
	
	function microtime_float() {
		list($usec, $sec) = explode(" ", microtime());
		return ((float)$usec + (float)$sec);
	}
	
	function secondsToStopwatchFormat($secs) {
		$s = $secs+0;
		if ($s>3599) {
			$h=floor($s / 3600.0);
			$s -= ($h*3600);
		}
		if ($secs>59) {
			$m=floor($s / 60.0);
			$s -= ($m*60);
		}
		return sprintf("%02u:%02u:%02u", $h, $m, $s);
	}

	function getBalanceForCurrentUser() {
		return getBalanceForUser($_SESSION["user"]["pKey"]+0);
	}
	
	function getUser($id) {
		$id = (string)$id+0;
		$r = mysql_query("SELECT * FROM benutzer b WHERE b.pKey=$id LIMIT 1");
		return mysql_fetch_array($r);
	}

	function getBalanceForUser($id) {
		$r=mysql_query("
			SELECT SUM(Zeilensumme) AS Balance FROM (
				SELECT 
							 b.Created,
				       p.Gueltig_ab VON,
				       (SELECT Gueltig_ab FROM preise WHERE Artikel_pKey = b.Artikel_pKey AND Gueltig_ab>VON ORDER BY Gueltig_ab ASC LIMIT 1) BIS,
				       (Artikel_Anzahl * Preis) Zeilensumme
				  FROM buchungen b LEFT
				  JOIN preise    p ON p.Artikel_pKey = b.Artikel_pKey LEFT
				  JOIN artikel   a ON a.pKey = b.Artikel_pKey
				 WHERE b.Belasteter_pKey = ". ($id+0) ."
				HAVING (b.Created BETWEEN VON AND BIS) OR (BIS IS NULL AND b.Created>VON)
				 ORDER BY b.Created ASC
				) t1
		") or die(mysql_error());
		$z=mysql_fetch_row($r);
		return (float) $z[0];
	}

	function getBalanceForGuestToken($id) {
		$r=mysql_query("
			SELECT SUM(Zeilensumme) AS Balance FROM (
				SELECT 
							 b.Created,
				       p.Gueltig_ab VON,
				       (SELECT Gueltig_ab FROM preise WHERE Artikel_pKey = b.Artikel_pKey AND Gueltig_ab>VON ORDER BY Gueltig_ab ASC LIMIT 1) BIS,
				       (Artikel_Anzahl * Preis) Zeilensumme
				  FROM buchungen b LEFT
				  JOIN preise    p ON p.Artikel_pKey = b.Artikel_pKey LEFT
				  JOIN artikel   a ON a.pKey = b.Artikel_pKey
				 WHERE b.Gaestetoken_pKey = ". ($id+0) ."
				HAVING (b.Created BETWEEN VON AND BIS) OR (BIS IS NULL AND b.Created>VON)
				 ORDER BY b.Created ASC
				) t1
		") or die(mysql_error());
		$z=mysql_fetch_row($r);
		return $z[0];
	}
	
	function validate822eMailAdress($address) {
		$v=file("config/email_validateregex.txt");
		$v=$v[0];
		$matches = array();
		$res = preg_match("/". $v ."/", $address, $matches);
		if ($res===false || $res ===0) { return false; } else { return $matches[0]; }
	}
	
	function getRandomVowelAndCharacter($length) {
		$vowels     = "aeiou";
		$consonants = "bcdfghjklmnpqrstvwxyz";
		$pw         = "";
		while (--$length>-1) {
			$i = rand(0,4);
			$pw .= $vowels[$i];
			$i = rand(0,20);
			$pw .= $consonants[$i];
		}
		$pw .= rand(0,9);
		$pw .= rand(0,9);
		return $pw;
	}	
	
	function resize($inputString, $fullContent="false", $max_width=120, $max_height=90){
		$image = @imagecreatefromstring($inputString);
		if ($image===false) { return false; }
		$w = @imagesx($image);
		$h = @imagesy($image);
		if ($h==0||$w==0) { return 1; }
		if ($fullContent=="true") {
			$max_width  = 800;
			$max_height = 600;
		}
		//1600:1200
		$v1 = $w/$h;
		//120:50
		$v2 = $max_width/$max_height;
		if ($v2 >= $v1) {
			$new_w = ($max_height / $h) * $w;
			$new_h = $max_height;	
		} else {
			$new_h = ($max_width / $w) * $h;
			$new_w = $max_width;
		}
		$im2 = ImageCreateTrueColor($new_w, $new_h);
		imagecopyresampled($im2, $image, 0, 0, 0, 0, $new_w, $new_h, $w, $h);
		return $im2;
	}
	
	function returnError($msg) {
		$img = imagecreatetruecolor(120, 60);
		$bg = imagecolorallocate($img, 0xFF, 0xFF, 0xFF);
		imagefilledrectangle($img, 0, 0, 200, 90, $bg);
		$color = imagecolorallocate($img, 255, 0, 0);
		imagestring($img, 2, 5, 5, "FEHLER:", $color);
		$color = imagecolorallocate($img, 0, 0, 0);
		imagestring($img, 2, 5, 20, $msg, $color);
		header('Content-Type: image/png');
		imagepng($img);
		exit;
	}

	function isSSL(){
		if($_SERVER['https'] == 1) /* Apache */ {
			return TRUE;
		} elseif ($_SERVER['https'] == 'on') /* IIS */ {
			return TRUE;
		} elseif ($_SERVER['SERVER_PORT'] == 443) /* others */ {
			return TRUE;
		} else {
			return FALSE; /* just using http */
		}
	}


	function createRandomVcKey() {
		// Konfiguration
		$pixelWidth=300;
		$pixelHeight=100;
		$bitsPerVcPixel=4;
		$stepsX = $pixelWidth / $bitsPerVcPixel;
		$stepsY = $pixelHeight / $bitsPerVcPixel;
		
		// Bild erzeugen
		$im = @ImageCreate($pixelWidth, $pixelHeight);
		if (!$im) { return false; }
		$redColor = imagecolorallocate($im, 255, 0, 0);
		$bluColor = imagecolorallocate($im, 0, 0, 255);
		
		//return "$stepsX::$stepsY";
		
		for ($i=0;$i<$stepsX;$i++) {
			for ($j=0;$j<$stepsY;$j++) {
				$rnd = rand(0,1);
				if ($rnd==1) {
					imagefilledrectangle($im, $i*$bitsPerVcPixel, $j*$bitsPerVcPixel, ($i*$bitsPerVcPixel)+$bitsPerVcPixel-1, ($j*$bitsPerVcPixel)+$bitsPerVcPixel-1,$redColor);
				} else {
					imagefilledrectangle($im, $i*$bitsPerVcPixel, $j*$bitsPerVcPixel, ($i*$bitsPerVcPixel)+$bitsPerVcPixel-1, ($j*$bitsPerVcPixel)+$bitsPerVcPixel-1,$bluColor);
				}
			}
		}
		
		// Ausgabe des Bildes als String
		ob_start();
		imagepng($im);
		$contents = ob_get_contents();
		ob_end_clean();
		imagedestroy($im);
		return $contents;
	}
	
	function getBarkasseSaldo() {
		$s=mysql_query("SELECT SUM(Preis) Preis FROM barkasse_buchungen");
		$rs=mysql_fetch_row($s);
		return $rs[0];
	}
	
?>