<?
	include("config/sysconfig.php");
	include("dbconnect.php");
	include("functions.php");
	

	$jahr  = $_GET["j"]+0;
	$monat = $_GET["m"]+0;
	$minMaxSteps = 4;
	$max   = floor(abs($_GET["max"]+0)*1.2);
	if ($max - abs($_GET["max"]+0) < $minMaxSteps) {
		$max += $minMaxSteps - ($max - abs($_GET["max"]+0));
	}
	

	$q=
	"
	SELECT
		a.Name,
		$jahr Jahr,
		$monat Monat,
		b.Created,
		STR_TO_DATE('$jahr-$monat-01', '%Y-%m-%d') ErsterTag,
		LAST_DAY(STR_TO_DATE('$jahr-$monat-01', '%Y-%m-%d')) LetzterTag,
		SUM(ABS(
			IF(
				b.Created BETWEEN
					STR_TO_DATE('$jahr-$monat-01 00:00:00', '%Y-%m-%d %H:%i:%s')
				AND
					DATE_ADD(LAST_DAY(STR_TO_DATE('$jahr-$monat-01' ,'%Y-%m-%d')), INTERVAL 86399 SECOND),
				b.Artikel_Anzahl, 
				0)
		)) Anzahl,
		e.Anz AnzahlForKing,
		u.Name,
		u.Vorname
	FROM artikel a LEFT
	JOIN buchungen b ON  (b.Artikel_pKey=a.pKey) LEFT
	JOIN (
		SELECT Art_pKey, Anzahl Anz, Belasteter_pKey CrownOwner FROM (
			SELECT
				a.pKey Art_pKey,
				SUM(ABS(
					IF(
						b.Created BETWEEN STR_TO_DATE('$jahr-$monat-01 00:00:00', '%Y-%m-%d %H:%i:%s') AND DATE_ADD( LAST_DAY(STR_TO_DATE('$jahr-$monat-01', '%Y-%m-%d')), INTERVAL 86399 SECOND ),
						b.Artikel_Anzahl, 
						0)
					)) Anzahl,
				b.Belasteter_pKey
			FROM artikel a LEFT
			JOIN buchungen b ON a.pKey=b.Artikel_pKey
			WHERE Buchbar='Y' AND Aktiv='Y' AND Ranking='Y' AND a.Sichtbar_in_Listen='Y'
			GROUP BY a.pKey, b.Belasteter_pKey
			ORDER BY Anzahl DESC
		) m
		GROUP BY Art_pKey				
	) e ON (e.Art_pKey=a.pKey) LEFT
	JOIN benutzer u ON e.CrownOwner = u.pKey
	WHERE Buchbar='Y' AND a.Aktiv='Y' AND a.Sichtbar_in_Listen='Y'
	GROUP BY a.pKey, Jahr, Monat
	ORDER BY Jahr DESC, Monat DESC, a.Name
	";
	$r=mysql_query($q) or die(mysql_error());
	$namen = array();
	$werte = array();
	$wleer = array();
	$crown = array();
	$crOwn = array();
	
	while ($z=mysql_fetch_row($r)) {
		//var_dump($z);
		array_push($namen, trim(utf8_decode(stripslashes($z[0]))).chr(10).' ');
		array_push($werte, $z[6]+0);
		array_push($wleer, 0);
		if ($z[8]) {
			if ($z[7]==0) {
				array_push($crOwn, trim(utf8_decode(stripslashes($z[0]))).': Niemand');
			} else {
				array_push($crOwn, trim(utf8_decode(stripslashes($z[0]))).': '. utf8_decode(stripslashes($z[8])) .", ". utf8_decode(stripslashes($z[9])));
			}
		} 
		if ($z[7]==$z[6] && $z[6]>0) { array_push($crown, 'Y'); } else { array_push($crown, 'N'); }
		
	}
	
	// Dieses Script wird die jeweiligen Bargraphen zeichnen.
	require_once ("jpgraph/jpgraph.php");
	require_once ("jpgraph/jpgraph_line.php");
	require_once ("jpgraph/jpgraph_bar.php");
	require_once ("jpgraph/jpgraph_iconplot.php");
	require_once ("jpgraph/jpgraph_text.inc.php");
	require_once ("jpgraph/jpgraph_log.php");
 
	 // Width and height of the graph
	$gDateLocale = new DateLocale();
	$gDateLocale->Set("");
	$mon = $gDateLocale->GetLongMonthName($monat-1); 
	
	$width = (count($namen)*40)+60;
	$height = 250;
	if (count($crOwn)>0) {
		$height += 20; //"Ranking:"
		$height += (count($crOwn))*15; //Fr jede Zeile 15px dazu.
	}
 
	// Create the graph.
	$graph = new Graph($width,$height);
	$graph->SetScale('textlog',0,0,0,0);
	$graph->SetMarginColor('white');
 
	// Setup title
	$graph->title->Set("$mon $jahr");
	
	//Beschriftungen
	$graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 7.5);
	$graph->xaxis->SetColor('black','darkblue');
	$graph->xaxis->SetLabelMargin(-5); 
	$graph->xaxis->SetLabelAngle(90); //45 degrees angle
	$graph->xaxis->SetLabelAlign('center','bottom');
	$graph->xaxis->SetTickLabels($namen); 

	// Create the first bar
	$bplot = new BarPlot($werte);
	$bplot->SetFillGradient('AntiqueWhite2','AntiqueWhite4:0.8',GRAD_VERT);
	$bplot->SetWidth(12);
	$bplot->SetColor('darkred');
	$bplot->SetAlign("center"); 

	$bplot->value->Show();
	$bplot->value->SetFont(FF_ARIAL,FS_NORMAL,10);
	$bplot->value->SetColor('black','darkred');
	$bplot->value->SetFormat('%1u');

	$bplot2 = new BarPlot($wleer);
	$gPlot = new GroupBarPlot(array($bplot2, $bplot));

	$txt = new Text("Ranking:");
	$txt->SetFont(FF_FONT1,FS_BOLD);
	$txt->SetPos(20, 242, 'left', 'top');
	$graph->AddText($txt);
	
	for ($i=0; $i<count($crOwn);$i++) {
		$txt = new Text($crOwn[$i]);
		$txt->SetFont(FF_FONT1,FS_NORMAL);
		$txt->SetPos(30, 260+($i*15), 'left', 'top');
		$graph->AddText($txt);
	}
	
	$tMargin  = 20;
	$bMargin  = 20;
	if (count($crOwn)>0) {
		$bMargin += 20; //"Ranking:"
		$bMargin += (count($crOwn))*15; //Fr jede Zeile 15px dazu.
	}
	$hDiagram = $height - $tMargin - $bMargin;
	
	$graph->Add($gPlot);
	/*
	for ($i=1; $i<(count($crown)+1); $i++) {
		if ($crown[$i-1]=='N') { continue; }
		$percent  = ((float)$werte[$i-1]/ (float)$max);
		$barTop   = $hDiagram - (($hDiagram-4)*$percent) - 20;
		$xoffset = 40 + ($i*40) - 22;
		$icon = new IconPlot('images/krone.png', $xoffset, $barTop, 0.7, 100); 
		$graph->Add($icon);
	}
	*/
	
	$graph->SetMargin(40,20,$tMargin,$bMargin);
	header('Content-Type: image/png');
	$graph->Stroke();
?>