<?
	include("config/sysconfig.php");
	include("dbconnect.php");
	include("functions.php");
	

	$jahr  = abs($_GET["j"]+0);

	$q=
	"
	SELECT
		a.Name,
		d.Jahr,
		d.Monat,
		SUM(ABS(
			IF(
				b.Created BETWEEN
					STR_TO_DATE(CONCAT('$jahr-', d.Monat, '-01 00:00:00'), '%Y-%m-%d %H:%i:%s')
				AND
					DATE_ADD(LAST_DAY(STR_TO_DATE(CONCAT('$jahr-', d.Monat, '-01') ,'%Y-%m-%d')), INTERVAL 86399 SECOND),
				b.Artikel_Anzahl, 
				0)
		)) Anzahl
	FROM artikel a LEFT
	JOIN buchungen b ON (b.Artikel_pKey=a.pKey) LEFT
	JOIN (
		SELECT DISTINCT
			YEAR(Created) Jahr,
			MONTH(Created) Monat
		FROM buchungen 
		HAVING Jahr = $jahr
		ORDER BY Jahr DESC, Monat ASC
	) d ON 1=1
	WHERE Buchbar='Y' AND a.Aktiv='Y' AND a.Sichtbar_in_Listen='Y'
	GROUP BY a.pKey, Jahr, Monat
	ORDER BY Monat ASC, a.Name
	";
	$r=mysql_query($q) or die(mysql_error());
	
	// Dieses Script wird die jeweiligen Linegraphen zeichnen.
	require_once ("jpgraph/jpgraph.php");
	require_once ("jpgraph/jpgraph_line.php");
	require_once ("jpgraph/jpgraph_bar.php");
	require_once ("jpgraph/jpgraph_iconplot.php");
	require_once ("jpgraph/jpgraph_text.inc.php");
	require_once ("jpgraph/jpgraph_log.php");

	$graph = new Graph(700, 300);
	$graph->SetScale('textlog');
	$graph->title->SetFont(FF_FONT1,FS_BOLD);
	$graph->title->Set("Verlauf $jahr");
	$graph->legend->Pos(0.03,0.08,'right','top');
	$graph->xaxis->SetTickLabels($gDateLocale->GetShortMonth());
	// Adjust the margin
	$graph->img->SetMargin(40,260,20,40);
 
	$datenArray = array();
	while ($z=mysql_fetch_row($r)) {
		// Zuerst Labels zusammenbauen
		if (!isset($datenArray[$z[0]])) { $datenArray[$z[0]] = array(); }
		while (count($datenArray[$z[0]])<($z[2]-1)) { array_push($datenArray[$z[0]], ''); } // Nicht vorhandene vorige Monate auffllen.
		array_push($datenArray[$z[0]], (int)$z[3]);
	}

	foreach ($datenArray as $key => &$value) {
		while (count($value)<12) { array_push($value, ''); } // Nicht vorhandene nachherige Monate auffllen.
		
		// Create the two linear plot
		$lineplot=new LinePlot($value);
		$lineplot->SetLegend(utf8_decode($key));
		$graph->Add($lineplot);
	}
	$graph->img->SetAntiAliasing();
	header('Content-Type: image/png');
	$graph->stroke();
?>