<?php
	include("../config/sysconfig.php");
	include("../dbconnect.php");
	include("../functions.php");
	
	function return_xmlrpc_error($errno,$errstr,$errfile=NULL,$errline=NULL,$errcontext=NULL){
		global $xmlrpc_server;
		if(!$xmlrpc_server) { die("Error: $errstr in '$errfile', line '$errline'"); }
		header("Content-type: text/xml; charset=UTF-8");
		print( xmlrpc_encode(array(
			  'faultCode'   => $errno
			, 'faultString' => "Remote XMLRPC Error from ".$_SERVER['HTTP_HOST'].": $errstr".
			  ($errfile?" in file ". $errfile:"") . ($errline?" at line ".$errline:"")
		)));
		die();
	}   

	function loginAndReturnUid($user, $pass) {
		$user = mysql_real_escape_string($user);
		$pass = sha1($pass);
		$r=mysql_query("SELECT pKey, Password, Aktiv FROM benutzer WHERE (LOWER(eMail)=LOWER('$user'))") or die(mysql_error());
		$uData=mysql_fetch_array($r);
		/* e("Account nicht gefunden."); */
		if (!$uData || strtolower($pass)!=$uData["Password"] ) { return_xmlrpc_error(403, "Anmeldung fehlgeschlagen, Benutzer oder Kennwort falsch."); } 
		/* e("Account ist deaktiviert."); */
		if (strtolower($uData["Aktiv"])!='y') { return_xmlrpc_error(404, "User deaktiviert."); }
		/* e("Account ist deaktiviert."); */
		if ($uData["pKey"]==0) { return_xmlrpc_error(404, "User nicht gefunden."); }
		return $uData["pKey"];
	}

	function getBalance($method_name, $params, $app_data) {
		$id = loginAndReturnUid($params[0]["user"], $params[0]["password"]);
		$returnArray=array();
		$returnArray["id"] = (int) $id;
		$returnArray["statusCode"] = 200;
		$returnArray["statusMsg"] = "Erfolg: Kontostand ermittelt und angehängt.";
		$returnArray["balance"] = getBalanceForUser($id);
		return $returnArray;
	}
	
	function bookArticleToUser($method_name, $params, $app_data) {
		$id     = loginAndReturnUid($params[0]["user"], $params[0]["password"]);
		$user   = getUser($id);
		$amount = (int)$params[0]["amount"]+0;
		$gtin   = mysql_real_escape_string($params[0]["gtin"]);
		
		if ($amount<1 || $amount>10) { return_xmlrpc_error(500, "$method_name: Bitte minimal 1 und maximal 10 Artikel buchen."); }
		$amount *= -1;
		
		$returnArray=array();
		$returnArray["id"] = (int) $id;
		
		$balancePreBooking = getBalanceForUser($id);
		
		$r=mysql_query("SELECT a.pKey, a.Name, a.Buchbar, a.GTIN, a.Verpackung, (SELECT Preis FROM preise WHERE Artikel_pKey=a.pKey ORDER BY Gueltig_ab DESC LIMIT 1) Preis FROM artikel a WHERE Aktiv='Y' AND GTIN = '$gtin'");
		$article = mysql_fetch_array($r);
		if (!$article) { return_xmlrpc_error(404, "$method_name: Artikel wurde nicht gefunden."); }
		if ($article["Buchbar"] && $article["Buchbar"]!='Y') { return_xmlrpc_error(500, "$method_name: Artikel kann nicht gebucht werden."); }
		
		mysql_query("INSERT INTO buchungen (pKey,Artikel_pKey,Artikel_Anzahl,Belasteter_pKey,Bucher_pKey) VALUES (NULL, ". $article["pKey"] .", $amount, $id, $id)");
		if ($errno=mysql_errno()) { return_xmlrpc_error(500, "DB-Fehler bei Buchung (vermutlich zu schnell hintereinander gebucht): ". $errno ." -- ". mysql_error()); }
		
		// Hier prüfen, ob wir noch eine ACHTUNG-Mail vershcicken müssen
		$returnArray["reminderMailSent"] = false;
		$r=mysql_query("SELECT * FROM mail_reminder WHERE Aktiv='Y' AND Send_Reminder_Instantly='Y' ORDER BY Betrag ASC");
		$aktiveReminder = array();
		while ($z=mysql_fetch_array($r)) { array_push($aktiveReminder, $z); }
		$balanceAfterBooking = getBalanceForUser($id);
		
		foreach ($aktiveReminder as $rm) {
			if (!($balancePreBooking>$rm["Betrag"] && $balanceAfterBooking<$rm["Betrag"])) { continue; }
			$text = $rm["Text"];
			$text = str_replace(chr(13).chr(10), chr(10), $text);
			$text = str_replace("%VORNAME%", $user["Vorname"], $text);
			$text = str_replace("%NAME%", $user["Name"], $text);
			if ($user["Geschlecht"]=='Herr') { $text = str_replace("%R_WENN_MANN%", "r", $text); } else { $text = str_replace("%R_WENN_MANN%", "", $text); }
			$text = str_replace("%ANREDE%", $user["Geschlecht"], $text);
			$text = str_replace("%BETRAG%", str_replace(".", ",", sprintf("%04.2f", $betrag2)), $text);
			$text = str_replace("%LIMIT%", str_replace(".", ",", sprintf("%04.2f", $rm["Betrag"])), $text);
			require_once("classes/class.phpmailer.php");
			$mail = new PHPMailer(true);
			$mail->IsSMTP();
			$mail->IsHTML(false);
			$mail->Host       = $globalMailServer_Address;
 			$mail->Port       = $globalMailServer_Port;
			$mail->SMTPAuth   = false;
			if ($globalMailServer_Username) {
		  	$mail->SMTPAuth   = true;
				$mail->Username = $globalMailServer_Username;
				$mail->Password = $globalMailServer_Password;
			}
			$mail->SMTPDebug  = 0;
			try {
				$mail->CharSet  = "utf-8";
				$mail->Encoding = "quoted-printable";
				$mail->SetFrom($globalMailServer_senderAddress, $globalMailServer_senderName);
				$mail->AddAddress($user["eMail"], $user["Vorname"] ." ". $user["Nachname"]);
				$mail->Subject = "I13I20SIT-Bar: Ihr Kontostand hat ". str_replace(".", ",", sprintf("%04.2f", $rm["Betrag"])) ." EUR überschritten.";
				$mail->Body    = $text;
				$mail->Send();
			} catch (phpmailerException $e) {
				return_xmlrpc_error(500, "Fehler der Mailer-Klasse: ". $e->errorMessage()); //Pretty error messages from PHPMailer*/
			} catch (Exception $e) {
				return_xmlrpc_error(500, "Fehler in PHP allgemein: ". $e->errorMessage()); //Pretty error messages from PHPMailer*/
			}
			$returnArray["reminderMailSent"] = true;
			break;
		}
		$article['Name'] = stripslashes($article['Name']);
		$amount *= -1;
		$returnArray["amountBooked"] = $amount;
		$returnArray["newBalance"]   = $balanceAfterBooking;
		$returnArray["statusCode"]   = 200;
		$returnArray["statusMsg"]    = "Erfolg: Artikel \"{$article['Name']}\" wurde {$amount}x erfolgreich gebucht.";
		return $returnArray;
	}
	
	function getLastTenBookings($method_name, $params, $app_data) {
		$id     = loginAndReturnUid($params[0]["user"], $params[0]["password"]);
		$returnArray=array();
		$returnArray["id"] = (int) $id;
		$r=mysql_query("
		SELECT 
			b.pKey AS Nr,
			a.pKey Artikelnummer,
			a.Name Artikelname,
			IF (b.Gaestetoken_pKey IS NULL, CONCAT(u.Vorname, ' ', u.Name), CONCAT('Gästetoken ', b.Gaestetoken_pKey)) AS Bucher,
			u.pKey bucherPkey,
			b.Created Erstellt,
			UNIX_TIMESTAMP(b.Created) Buchungsdatum,
			p.Preis Einzelpreis,
			p.Gueltig_ab VON,
			(SELECT Gueltig_ab FROM preise WHERE Artikel_pKey = Artikelnummer AND Gueltig_ab>VON ORDER BY Gueltig_ab ASC LIMIT 1) BIS,
			b.Artikel_Anzahl Anzahl,
			(Artikel_Anzahl * Preis) Zeilensumme
		FROM buchungen b LEFT
		JOIN benutzer  u ON b.Bucher_pKey = u.pKey LEFT
		JOIN preise    p ON p.Artikel_pKey = b.Artikel_pKey LEFT
		JOIN artikel   a ON a.pKey = b.Artikel_pKey
		WHERE b.Belasteter_pKey = $id
		HAVING (b.Created BETWEEN VON AND BIS) OR (BIS IS NULL AND b.Created>VON)
		ORDER BY b.Created DESC
		LIMIT 10
		") or die(mysql_error());
		$returnArray["lastTenItems"] = array();
		$i = 0;
		while ($buchung = mysql_fetch_array($r)) {
			$i++;
			$returnArray["lastTenItems"][$i] = array(
				"Nr"            => (int)$buchung["Nr"],
				"Artikelnummer" => (int)$buchung["Artikelnummer"],
				"Buchungsdatum" => (int)$buchung["Buchungsdatum"],
				"Einzelpreis"   => (float)$buchung["Einzelpreis"],
				"Anzahl"        => (int)$buchung["Anzahl"],
				"Zeilensumme"   => (float)$buchung["Zeilensumme"],
				"Artikelname"   => stripslashes($buchung["Artikelname"]),
				"Bucher"        => stripslashes($buchung["Bucher"]),
			);
		}
		$returnArray["statusCode"]   = 200;
		$returnArray["statusMsg"]    = "Erfolg: Letzte 10 Artikel erfolgreich ermittelt.";
		return $returnArray;
	}

	if (!function_exists("xmlrpc_server_create")) die("Sorry, no xml-rpc support...");
	$xmlrpc_server = xmlrpc_server_create();
	set_error_handler('return_xmlrpc_error');	
	xmlrpc_server_register_method($xmlrpc_server, "getBalance", "getBalance");
	xmlrpc_server_register_method($xmlrpc_server, "bookArticleToUser", "bookArticleToUser");
	xmlrpc_server_register_method($xmlrpc_server, "getLastTenBookings", "getLastTenBookings");
	

	$request_xml = $HTTP_RAW_POST_DATA;
	$response = xmlrpc_server_call_method($xmlrpc_server, $request_xml, '');
	print $response;
	xmlrpc_server_destroy($xmlrpc_server);
?>