<?php
	session_start();
	if ($_SESSION["user"]["pKey"]==0) {
		header("Location: index.php?l=1");
		exit;
	}	
	if ($_SESSION["user"]["Kassenwart"]!='Y') {
		header("Location: main.php");
		exit;
	}	
	if (!$ticketParent=="ok") {
		header('Location: main.php');
		exit;
	}
	$acYear = $_REQUEST["acYear"]+0;
	
	function roundFiveCentsUp($wert) {
		$val = $wert * 100;
		$mmod = $val % 5;
		if ($mmod>0) { $val += (5-$mmod); }
		$val /= 100;
		return $val;
	}
?>

<div id="queueHeader">AutoCalc für Preise</div>
<form name="form1" id="form1" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?module=kw_kalkulator" style="margin:0" enctype="multipart/form-data">
<table cellpadding="2" cellspacing="2" border="0" style="margin-bottom:10px; border:1px solid #666">
	<tr><th colspan="2" align="left">Preiskalkulator</th></tr>
	<tr><td colspan="2">
	Dieses Tool berechnet für <em>buchbare</em> Artikel die Preise, um die Kosten
	aller Artikel (z.B. Spülmittel, Filterpatronen, Lappen, verlorener Pfand usw.)
	gemeinschaftlich tragen zu können. Bitte tragen Sie daher in der Barkassenverwaltung
	eingehende Rechnungen möglichst gut aufgeschlüsselt nach Produkten ein.
	</td></tr>
	<tr>
		<td class="configLabel">Jahr<strong style="color:#F00">*</strong>:</td>
		<td class="configValue">
			<select name="acYear" onchange="document.getElementById('form1').submit();">
				<option value="0">Bitte ein Jahr wählen...</option>
				<?
					$r=mysql_query("SELECT DISTINCT YEAR(Created) Jahr FROM buchungen ORDER BY Jahr DESC");
					while($j=mysql_fetch_row($r)) {
				?>
				<option value="<?php echo $j[0]; ?>" <?php if($j[0]==$acYear) { ?> selected="selected"<?php } ?>><?php echo $j[0]; ?></option>
				<?php } ?>
			</select>
			<div class="helpText">Wählen Sie hier das Jahr aus, das für als Grundlage der Berechnung dienen soll.</div>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td><input type="submit" name="acYearSubmit" value="Berechnung starten" /></td>
	</tr>
</table>
</form>

<?
	if ($acYear>0) {
		$r=mysql_query("
SELECT
  pKey,
  Name,
  Gesamtanzahl_VK,
  Gesamtpreis_EK,
  Gesamtanzahl_EK,
  Einzelpreis_EK,
	Gesamtpreis_EK/IF(Gesamtanzahl_VK>Gesamtanzahl_EK,Gesamtanzahl_VK,Gesamtanzahl_EK) Einzelpreis_VK,
	Preis Einzelpreis_Aktuell_VK,
  Buchbar
FROM (
SELECT
  a.pKey,
  a.Name,
  SUM(
		IF(
			ABS(b.Artikel_Anzahl)>0
			AND
			b.Created BETWEEN STR_TO_DATE('$acYear-01-01', '%Y-%m-%d') AND STR_TO_DATE('$acYear-12-31 23:59:59', '%Y-%m-%d %H:%i:%s')
		, ABS(b.Artikel_Anzahl)
		, 0
		)
	) Gesamtanzahl_VK,
  bk.Gesamtanzahl_EK,
  bk.Gesamtpreis_EK,
  bk.Gesamtpreis_EK/bk.Gesamtanzahl_EK Einzelpreis_EK,
	(SELECT Preis FROM preise WHERE Artikel_pKey=a.pKey ORDER BY Gueltig_ab DESC LIMIT 1) Preis,
  a.Buchbar
FROM artikel a LEFT
JOIN buchungen b ON (a.pKey=b.Artikel_pKey /* OR b.Artikel_pKey = 0 OR  b.Artikel_pKey = NULL OR b.Artikel_pKey IS NULL */ ) LEFT 
JOIN (
  SELECT
    a.pKey Artikel_pKey,
    ABS(SUM(bk.Preis)) Gesamtpreis_EK,
    ABS(SUM(bk.Artikel_Anzahl * bk.Preis / IF(bk.Preis=0, 1, ABS(bk.Preis)))) Gesamtanzahl_EK
  FROM artikel a LEFT
  JOIN barkasse_buchungen bk ON bk.Artikel_pKey=a.pKey
  WHERE (bk.Buchungsdatum BETWEEN STR_TO_DATE('$acYear-01-01', '%Y-%m-%d') AND STR_TO_DATE('$acYear-12-31 23:59:59', '%Y-%m-%d %H:%i:%s'))
  GROUP BY a.pKey
) bk ON (bk.Artikel_pKey = a.pKey OR a.pKey IS NULL)
WHERE 1=1
  AND a.pKey != 1 /* Keine Einzahlungen */
  AND a.Aktiv='Y'
GROUP BY a.pKey
ORDER BY Buchbar ASC, a.Name ASC
) m
");
	$artikelArrayBuchbar = array();
	$artikelArrayNichtBuchbar = array();
	$summeNichtBuchbar  = 0;
	$anzahlBuchbar      = 0;
	$anzahlNichtBuchbar = 0;
	while ($a=mysql_fetch_array($r)) {
		if ($a["Buchbar"]=='N') {
			$anzahlNichtBuchbar++;
			$summeNichtBuchbar += $a["Gesamtpreis_EK"];
			array_push($artikelArrayNichtBuchbar , $a);
		} else {
			$anzahlBuchbar++;
			array_push($artikelArrayBuchbar , $a);
		}
	}
	
	$preisAufschlagFuerJedenBuchbarenArtikel = $summeNichtBuchbar / $anzahlBuchbar;
?>
	<!--
	Es wurde berechnet mit den jeweils bisher verkauften Artikeln, um wieviel<br />
	der Preis jedes buchbaren Artikels im Gegensatz zum aktuellen Preis geändert<br />
	werden muss, damit die nicht-buchbaren Artikel quersubventioniert werden<br />
	können.<br />
	Es wird dabei der gleiche Verbrauch aus dem ausgewählten Jahr angenommen.<br />
	<br />
	
	Summe nicht-buchbare Ausgaben: <?php echo $summeNichtBuchbar; ?><br />
	Anzahl nicht-buchbare Artikel: <?php echo $anzahlNichtBuchbar; ?><br />
	Anzahl buchbare Artikel: <?php echo $anzahlBuchbar; ?><br />
	Preisaufschlag pro Artikel: <?php echo $preisAufschlagFuerJedenBuchbarenArtikel; ?><br />
	<br />
	-->
	<script language="javascript">
	<!--
		var Gesamtanzahl_EK_array = new Array();
		var Gesamtpreis_EK_array  = new Array();
	-->
	</script>
	<table>
		<tr>
			<td colspan="5" bgcolor="#dddddd"><strong>Nicht buchbare Artikel, Zusatzausgaben</strong></td>
		</tr>
		<tr bgcolor="#eeeeee" align="center" style="font-weight:bold">
			<td>Artikel</td>
			<td>Eingekauft<div style="font-size:0.7em">Anzahl</div></td>
			<td>EK Einzel<div style="font-size:0.7em">aus Einkauf</div></td>
			<td>EK Gesamt<div style="font-size:0.7em">laut Barkasse</div></td>
			<td bgcolor="#FFFFFF">Verteilen auf:</td>
		</tr>
		<?
			foreach($artikelArrayNichtBuchbar as $artikel) {
				$pKey = $artikel["pKey"];
				$temp = 0;
				$Gesamtanzahl_EK   = (int)$artikel["Gesamtanzahl_EK"];
				$Einzelpreis_EK    = str_replace(".",",", sprintf("%04.2f", round($artikel["Einzelpreis_EK"], 2)));
				$Gesamtpreis_EK    = str_replace(".",",", sprintf("%04.2f", round($artikel["Gesamtpreis_EK"], 2)));
				$summeNichtBuchbar2 = str_replace(".",",", sprintf("%04.2f", round($summeNichtBuchbar, 2)));
				
		?>
		<tr onmouseover="this.style.background='#ffebcb';" onmouseout="this.style.background='#fff';">
			<td nowrap="nowrap"><?php echo $artikel["Name"]; ?></td> 
			<td align="center">
				<?php echo $Gesamtanzahl_EK; ?>
			</td>
			<td align="right" nowrap="nowrap">
				<?php echo $Einzelpreis_EK; ?> &euro;
			</td>
			<td align="right" nowrap="nowrap">
				<input type="text" id="Verteiler_nbArtikelBetrag_<?php echo $pKey; ?>" class="formfields" value="<?php echo $Gesamtpreis_EK; ?>" size="6" onblur="recalcNbArticles();" /> &euro;
			</td>
			<td align="right" nowrap="nowrap">
				<select id="Verteiler_nbArtikelPkey_<?php echo $pKey; ?>">
					<option value="0">Alle buchbaren Artikel...</option>
					<?php foreach ($artikelArrayBuchbar as $bArtikel) { ?>
					<option value="<?php echo $bArtikel["pKey"]; ?>"><?php echo $bArtikel["Name"]; ?></option>
					<?php } ?>
				</select>
			</td>
		</tr> 
		<?php } ?>
		<tr>
			<td style="font-weight:bold" colspan="3" align="right">SUMME:</td>
			<td style="font-weight:bold" align="right">
				<input type="text" maxlength="7" size="5" value="<?php echo $summeNichtBuchbar2; ?>" name="Summe_NB" id="Summe_NB" class="formfields" style="text-align:right" onblur="this.value=kaufm(parseFloat(this.value.replace(',','.'))).replace('.',',')" />	&euro;
			</td>
			<td>
				<input type="button" value="linear" onclick="vertLinear();" title="Verteilt den Betrag von <?php echo $summeNichtBuchbar2; ?> EUR gleichmäßig auf alle buchbaren Artikel." />
				<input type="button" value="gewichtet"  onclick="vertGewichtet();" title="Verteilt den Betrag von <?php echo $summeNichtBuchbar2; ?> EUR mit der Anzahl konsumierter Einheiten gewichtet auf alle buchbaren Artikel." />
				<input type="button" value="Auswahl"  onclick="vertAuswahl();" />
			</td>
		</tr>
	</table>
	<br />
	<form name="form1" id="form1" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?module=kw_kalkulator" style="margin:0">
	<table>
		<tr>
			<td colspan="10" bgcolor="#dddddd"><strong>Buchbare Artikel</strong></td>
		</tr>
		<tr bgcolor="#eeeeee" align="center" style="font-weight:bold">
			<td>Artikel</td>
			<td>Verbrauch<div style="font-size:0.7em">Anzahl</div></td>
			<td>Eingekauft<div style="font-size:0.7em">Anzahl</div></td>
			<td>EK Einzel<div style="font-size:0.7em">aus Einkauf</div></td>
			<td>EK Gesamt<div style="font-size:0.7em">laut Barkasse</div></td>
			<td>VK Einzel<div style="font-size:0.7em">aus Verbrauch oder Einkauf</div></td>
			<td>VK Einzel<div style="font-size:0.7em">derzeitig</div></td>
			<td>Aufschlag<div style="font-size:0.7em">aus n.b. Artikeln</div></td>
			<td>Aufschlag<div style="font-size:0.7em">pro Stück</div></td>
			<td>VK Einzel NEU<div style="font-size:0.7em">mit Quersubvention</div></td>
		</tr>
		<?
			foreach($artikelArrayBuchbar as $artikel) {
				$pKey = $artikel["pKey"];
				$temp = 0;
				$Gesamtanzahl_VK = (int)$artikel["Gesamtanzahl_VK"];
				$Gesamtanzahl_EK = (int)$artikel["Gesamtanzahl_EK"];
				$Einzelpreis_EK  = str_replace(".",",", sprintf("%04.2f", round($artikel["Einzelpreis_EK"], 2)));
				$Gesamtpreis_EK  = str_replace(".",",", sprintf("%04.2f", round($artikel["Gesamtpreis_EK"], 2)));
				$Einzelpreis_VK  = str_replace(".",",", sprintf("%04.2f", round($artikel["Einzelpreis_VK"], 2)));
				$Einzelpreis_Aktuell_VK = str_replace(".",",",$artikel["Einzelpreis_Aktuell_VK"]);
				$Preisaufschlag_Gesamt  = str_replace(".",",", sprintf("%04.2f", round($preisAufschlagFuerJedenBuchbarenArtikel, 2)));
				if (max($Gesamtanzahl_VK,$Gesamtanzahl_EK)==0) { $temp = 1; }
				$Preisaufschlag_Einzel  = str_replace(".",",", sprintf("%04.2f", round($preisAufschlagFuerJedenBuchbarenArtikel/max($Gesamtanzahl_VK,$Gesamtanzahl_EK, $temp), 2)));
				$Einzelpreis_Final_VK   = round($preisAufschlagFuerJedenBuchbarenArtikel/max($Gesamtanzahl_VK,$Gesamtanzahl_EK, $temp) + $artikel["Einzelpreis_VK"], 2);
				$Einzelpreis_Final_VK   = str_replace(".",",", sprintf("%04.2f", roundFiveCentsUp($Einzelpreis_Final_VK)));
		?>
		<tr onmouseover="this.style.background='#ffebcb';" onmouseout="this.style.background='#fff';">
			<td nowrap="nowrap"><?php echo $artikel["Name"]; ?></td> 
			<td align="center">
				<input type="text" maxlength="5" size="5" value="<?php echo $Gesamtanzahl_VK; ?>" name="Gesamtanzahl_VK_<?php echo $pKey; ?>" id="Gesamtanzahl_VK_<?php echo $pKey; ?>" class="formfields" style="text-align:right" onblur="recalcLine(this);" />
			</td>
			<td align="center">
				<input type="text" maxlength="5" size="5" value="<?php echo $Gesamtanzahl_EK; ?>" name="Gesamtanzahl_EK_<?php echo $pKey; ?>" id="Gesamtanzahl_EK_<?php echo $pKey; ?>" class="formfields" style="text-align:right; background-color:#FFE" onblur="recalcLineEK(this);" />
			</td>
			<td align="right" nowrap="nowrap">
				<input type="text" maxlength="5" size="5" value="<?php echo $Einzelpreis_EK; ?>" name="Einzelpreis_EK_<?php echo $pKey; ?>" id="Einzelpreis_EK_<?php echo $pKey; ?>" class="formfields" style="text-align:right; background-color:#FFE" onblur="recalcLineEK(this);" />	&euro;
			</td>
			<td align="right" nowrap="nowrap">
				<input type="text" maxlength="7" size="5" value="<?php echo $Gesamtpreis_EK; ?>" name="Gesamtpreis_EK_<?php echo $pKey; ?>" id="Gesamtpreis_EK_<?php echo $pKey; ?>" class="formfields" style="text-align:right; background-color:#FFE" onblur="recalcLineEK(this);" />	&euro;
			</td>

			<td align="center" nowrap="nowrap">
				<input type="text" maxlength="8" size="8" value="<?php echo $Einzelpreis_VK; ?>" name="Einzelpreis_VK_<?php echo $pKey; ?>" id="Einzelpreis_VK_<?php echo $pKey; ?>" class="formfields" style="text-align:right; background-color:#EEE" readonly="readonly" /> &euro;
			</td>

			<td align="right" nowrap="nowrap">
				<input type="text" maxlength="8" size="8" value="<?php echo $Einzelpreis_Aktuell_VK; ?>" name="Einzelpreis_Aktuell_VK_<?php echo $pKey; ?>" id="Einzelpreis_Aktuell_VK_<?php echo $pKey; ?>" class="formfields" style="text-align:right; background-color:#EEE; font-weight:bold; color:<?php if ($Einzelpreis_Aktuell_VK>$Einzelpreis_VK) { ?>#090<?php } else { ?>#F00<?php } ?>" readonly="readonly" /> &euro;
			</td>

			<td nowrap="nowrap">
				<input type="text" maxlength="8" size="8" value="<?php echo $Preisaufschlag_Gesamt; ?>" name="Preisaufschlag_Gesamt_<?php echo $pKey; ?>" id="Preisaufschlag_Gesamt_<?php echo $pKey; ?>" class="formfields" style="text-align:right; background-color:#EFF" onfocus="storeOldValue(this);" onblur="recalcAufschlaege(this);" /> &euro;
			</td>
			<td nowrap="nowrap">
				<input type="text" maxlength="8" size="8" value="<?php echo $Preisaufschlag_Einzel; ?>" name="Preisaufschlag_Einzel_<?php echo $pKey; ?>" id="Preisaufschlag_Einzel_<?php echo $pKey; ?>" class="formfields" style="text-align:right; background-color:#EEE" readonly="readonly" /> &euro;
			</td>
			
			<td align="right" nowrap="nowrap">
				<input type="text" maxlength="8" size="8" value="<?php echo $Einzelpreis_Final_VK; ?>" name="EinzelpreisFinal_VK_<?php echo $pKey; ?>" id="EinzelpreisFinal_VK_<?php echo $pKey; ?>" class="formfields" style="text-align:right" onblur="this.value=kaufm(parseFloat(this.value.replace(',','.'))).replace('.',',')" /> &euro;
			</td>
		</tr> 
		<?php } ?>
		<tr><td colspan="10" align="right" bgcolor="#EEEEEE">&nbsp;</td></tr>
		<tr>
			<td colspan="10" align="right">
				<input type="submit" value="neue Preise festlegen" name="enterNewPrices" onclick="return confirm('Möchten Sie wirklich obige Preise ab jetzt übernehmen?');" />
			</td>
		</tr>
	</table>
	</form>

<script language="javascript" type="text/javascript">
<!--
	var summeAufschlag = <?php echo $summeNichtBuchbar; ?>;
	var anzahlBuchbar  = <?php echo $anzahlBuchbar; ?>;
	var oldValue = 0;
	
	function kaufm(x) {
		var k = (Math.round(x * 100) / 100).toString();
		k += (k.indexOf('.') == -1)? '.00' : '00';
		return k.substring(0, k.indexOf('.') + 3);
	}
	
	function roundFiveCentsUp(wert) {
		var val = wert * 100;
		var mmod = val % 5;
		if (mmod>0) { val += (5-mmod); }
		val /= 100;
		return val;
	}

	function recalcLineEK(el) {
		var pKey            = el.id.split('_')[2];
		var Gesamtanzahl_EK = document.getElementById('Gesamtanzahl_EK_'+pKey).value;
		var Einzelpreis_EK  = document.getElementById('Einzelpreis_EK_'+pKey).value;
		var Gesamtpreis_EK  = document.getElementById('Gesamtpreis_EK_'+pKey).value;
		
		Gesamtanzahl_EK = parseInt(Gesamtanzahl_EK);
		Einzelpreis_EK  = parseFloat(Einzelpreis_EK.replace(',','.'));
		Gesamtpreis_EK  = parseFloat(Gesamtpreis_EK.replace(',','.'));
		if (el.id.indexOf('Gesamtanzahl_EK')==0 || el.id.indexOf('Einzelpreis_EK')==0) {
			// Anzahl oder Einzelpreis geändert: Gesamtpreis neu berechnen
			Gesamtpreis_EK = kaufm(Gesamtanzahl_EK * Einzelpreis_EK);
			document.getElementById('Gesamtpreis_EK_'+pKey).value = Gesamtpreis_EK.toString().replace('.',',');
			document.getElementById('Einzelpreis_EK_'+pKey).value = kaufm(Einzelpreis_EK).toString().replace('.',',');
		} else {
			// Gesamtpreis geändert: Einzelpreis neu berechnen
			Einzelpreis_EK  = kaufm(Gesamtpreis_EK / Gesamtanzahl_EK);
			document.getElementById('Einzelpreis_EK_'+pKey).value = Einzelpreis_EK.toString().replace('.',',');
			document.getElementById('Gesamtpreis_EK_'+pKey).value = kaufm(Gesamtpreis_EK).toString().replace('.',',');
		}
		recalcLine(el);
	}
	
	function recalcLine(el) {
		var elName = el.id;
		var pKey   = elName.split('_')[2];
		var Gesamtanzahl_VK = parseInt(document.getElementById('Gesamtanzahl_VK_'+pKey).value);
		var Gesamtanzahl_EK = parseInt(document.getElementById('Gesamtanzahl_EK_'+pKey).value);
		var Gesamtpreis_EK  = parseFloat(document.getElementById('Gesamtpreis_EK_'+pKey).value.replace(',','.'));
		var Einzelpreis_Aktuell_VK = parseFloat(document.getElementById('Einzelpreis_Aktuell_VK_'+pKey).value.replace(',','.'));
		var Preisaufschlag_Gesamt  = parseFloat(document.getElementById('Preisaufschlag_Gesamt_'+pKey).value.replace(',','.'));

		// Stückpreis VK aufgrund der EK-Daten berechnen
		if (Gesamtanzahl_VK>Gesamtanzahl_EK) {
			var Einzelpreis_VK = Gesamtpreis_EK / Gesamtanzahl_VK;
			var Preisaufschlag_Einzel = Preisaufschlag_Gesamt / Gesamtanzahl_VK;
		} else {
			var Einzelpreis_VK = Gesamtpreis_EK / Gesamtanzahl_EK;
			var Preisaufschlag_Einzel = Preisaufschlag_Gesamt / Gesamtanzahl_EK;
		}
		if (Einzelpreis_Aktuell_VK<Einzelpreis_VK) { document.getElementById('Einzelpreis_Aktuell_VK_'+pKey).style.color='#F00'; } else { document.getElementById('Einzelpreis_Aktuell_VK_'+pKey).style.color='#090'; } 
		
		document.getElementById('Einzelpreis_VK_'+pKey).value = kaufm(Einzelpreis_VK).replace('.',',');
		document.getElementById('Preisaufschlag_Einzel_'+pKey).value = kaufm(Preisaufschlag_Einzel).replace('.',',');
		document.getElementById('EinzelpreisFinal_VK_'+pKey).value = kaufm(roundFiveCentsUp(Einzelpreis_VK+Preisaufschlag_Einzel)).replace('.',',');
	}
	
	function storeOldValue(el) {
		oldValue = parseFloat(el.value.replace(',','.'));
	}
	
	function recalcAufschlaege(el) {
		var value = parseFloat(el.value.replace(',','.'));
		if (isNaN(value) || value < 0) {
			el.value = kaufm(oldValue).replace('.',',');
			return;
		}
		el.value = kaufm(value).replace('.',',');
		var differenz = oldValue - value;
		var diffProArtikel = differenz / anzahlBuchbar;

		var inputs = document.getElementsByTagName('input');
		var pKey_array = new Array();
		for (var i=0;i<inputs.length;i++) {
			var pKey   = inputs[i].id.split('_')[2];
			if (inputs[i].id.indexOf('Preisaufschlag_Gesamt')==0) { pKey_array.push(pKey); }
			
			if (inputs[i].id.indexOf('Preisaufschlag_Gesamt')!=0 || inputs[i].id==el.id) { continue; }
			var wert = parseFloat(inputs[i].value.replace(',','.'));
			wert += diffProArtikel;
			inputs[i].value = kaufm(wert).replace('.',',');
		}
		
		for (i=0;i<pKey_array.length;i++) {
			recalcLine(document.getElementById('Gesamtanzahl_VK_'+pKey_array[i]));
		}
	}
	
	function vertLinear() {
		var valForEachProduct = parseFloat(document.getElementById('Summe_NB').value.replace(',','.')) / anzahlBuchbar;
		
		var inputs = document.getElementsByTagName('input');
		var pKey_array = new Array();
		for (var i=0;i<inputs.length;i++) {
			var pKey   = inputs[i].id.split('_')[2];
			if (inputs[i].id.indexOf('Preisaufschlag_Gesamt')!=0) { continue; }
			pKey_array.push(pKey);
			inputs[i].value = kaufm(valForEachProduct).replace('.',',');
		}
		for (i=0;i<pKey_array.length;i++) {
			recalcLine(document.getElementById('Gesamtanzahl_VK_'+pKey_array[i]));
		}
	}

	function vertGewichtet() {
		var Gesamtzahl_Verbrauch = 0;
		var valOverall = parseFloat(document.getElementById('Summe_NB').value.replace(',','.'));
		
		var inputs = document.getElementsByTagName('input');
		var pKey_array = new Array();
		
		for (var i=0;i<inputs.length;i++) {
			var pKey   = inputs[i].id.split('_')[2];
			if (inputs[i].id.indexOf('Gesamtanzahl_VK_')!=0) { continue; }
			pKey_array.push(pKey);
			Gesamtzahl_Verbrauch += parseInt(inputs[i].value);
		}
		
		for (var i=0;i<pKey_array.length;i++) {
			var currentNumber = parseInt(document.getElementById('Gesamtanzahl_VK_'+pKey_array[i]).value);
			document.getElementById('Preisaufschlag_Gesamt_'+pKey_array[i]).value = kaufm(currentNumber / Gesamtzahl_Verbrauch * valOverall).replace('.',',');
		}
		
		for (i=0;i<pKey_array.length;i++) { recalcLine(document.getElementById('Gesamtanzahl_VK_'+pKey_array[i])); }
	}

	function recalcNbArticles() {
		var summe = 0;
		var inputs = document.getElementsByTagName('input');
		var pKey_Buchbar_Array = new Array();
		var pKey_Verteiler_Array = new Array();
		var Betrag_Auf_Produkt_Array = new Array();

		// Alle buchbar-Artikel-Zeilen bestimmen
		for (var i=0;i<inputs.length;i++) {
			var pKey   = inputs[i].id.split('_')[2];
			if (inputs[i].id.indexOf('Verteiler_nbArtikelBetrag_')!=0) { continue; }
			document.getElementById('Verteiler_nbArtikelBetrag_'+pKey.toString()).value = kaufm(document.getElementById('Verteiler_nbArtikelBetrag_'+pKey.toString()).value.replace(',','.')).replace('.',',');
			summe += parseFloat(document.getElementById('Verteiler_nbArtikelBetrag_'+pKey.toString()).value.replace(',','.'));
		}
		
		document.getElementById('Summe_NB').value = kaufm(summe).toString().replace('.',',');
	}

	function vertAuswahl() {
		var inputs = document.getElementsByTagName('input');
		var pKey_Buchbar_Array = new Array();
		var pKey_Verteiler_Array = new Array();
		var Betrag_Auf_Produkt_Array = new Array();
		var pKey_array = new Array();

		// Alle buchbar-Artikel-Zeilen bestimmen
		for (var i=0;i<inputs.length;i++) {
			var pKey   = inputs[i].id.split('_')[2];
			if (inputs[i].id.indexOf('Gesamtanzahl_VK_')==0) { pKey_Buchbar_Array.push(pKey); }
			if (inputs[i].id.indexOf('Verteiler_nbArtikelBetrag_')==0)       { pKey_Verteiler_Array.push(pKey); }
		}
		
		//Maximum der pKeys der Buchbaren Artikel herausfinden und array initialisieren.
		var mx = 0;
		for (var i=0;i<pKey_Verteiler_Array.length;i++) {
			// Ok, was soll wohin verteilt werden?
			var sel = document.getElementById("Verteiler_nbArtikelPkey_"+pKey_Verteiler_Array[i].toString());
			var Buchbar_Produkt_pKey = parseInt(sel.options[sel.selectedIndex].value);
			if (mx < Buchbar_Produkt_pKey) { mx = Buchbar_Produkt_pKey; }
		}
		
		for (var i=0; i<mx+1; i++) { Betrag_Auf_Produkt_Array.push(0.0); }
		
		for (var i=0;i<pKey_Verteiler_Array.length;i++) {
			// Ok, was soll wohin verteilt werden?
			var sel = document.getElementById("Verteiler_nbArtikelPkey_"+pKey_Verteiler_Array[i].toString());
			var Buchbar_Produkt_pKey = parseInt(sel.options[sel.selectedIndex].value);
			var Betrag_zu_Verteilen  = parseFloat(kaufm(parseFloat(document.getElementById('Verteiler_nbArtikelBetrag_'+pKey_Verteiler_Array[i].toString()).value.replace(',','.'))));
			//Betrag_Auf_Produkt_Array.push(Buchbar_Produkt_pKey.toString() +"||"+ Betrag_zu_Verteilen.toString());
			//alert (Buchbar_Produkt_pKey + " :: " + Betrag_zu_Verteilen + " :: " + i + " :: " + Betrag_Auf_Produkt_Array[Buchbar_Produkt_pKey]);
			var tmp = parseFloat(Betrag_Auf_Produkt_Array[Buchbar_Produkt_pKey]);
			//alert (i +": " + Buchbar_Produkt_pKey + " || " + Betrag_zu_Verteilen + " || " + tmp);
			Betrag_Auf_Produkt_Array[Buchbar_Produkt_pKey] = Betrag_zu_Verteilen + tmp;
		}
		
		for (var i=0;i<inputs.length;i++) {
			var pKey   = inputs[i].id.split('_')[2];
			if (inputs[i].id.indexOf('Gesamtanzahl_VK_')!=0) { continue; }
			pKey_array.push(pKey);
		}
		var allgemein_zu_verteilen   = Betrag_Auf_Produkt_Array[0];
		var allgemein_pro_bb_produkt = parseFloat(kaufm(allgemein_zu_verteilen/(pKey_array.length*1.0)));
		
		for (var i=0;i<pKey_array.length;i++) {
			var fuerProdukt = 0;
			var pKey = pKey_array[i];
			if (isNaN(Betrag_Auf_Produkt_Array[pKey])) {
				var Betrag = 0;
			} else {
				var Betrag = Betrag_Auf_Produkt_Array[pKey];
			}
			document.getElementById('Preisaufschlag_Gesamt_'+pKey_array[i]).value = kaufm(Betrag + allgemein_pro_bb_produkt).replace('.',',');
		}

		for (i=0;i<pKey_Buchbar_Array.length;i++) {
			recalcLine(document.getElementById('Gesamtanzahl_VK_'+pKey_Buchbar_Array[i]));
		}
		
	}

-->
</script>
<?php } ?>