<?
	include("config/sysconfig.php");
	include("dbconnect.php");
	include("functions.php");
	

	$jahr    = abs($_GET["j"]+0);
	$monat   = abs($_GET["m"]+0);
	$artikel = abs($_GET["a"]+0);
	$limit   = (abs($_GET["l"]+0)?abs($_GET["l"]+0):5);

	$q="
		SELECT * FROM (
		SELECT
		  u.Name Familienname,
		  u.Vorname,
		  ABS(SUM(b.Artikel_Anzahl)) Anzahl
		FROM artikel a LEFT
		JOIN buchungen b ON a.pKey=b.Artikel_pKey LEFT
		JOIN benutzer  u ON u.pKey=b.Belasteter_pKey
		WHERE a.Ranking='Y' AND a.Aktiv='Y'
		AND b.Created BETWEEN '$jahr-$monat-01' AND LAST_DAY('$jahr-$monat-01')
		AND a.pKey = $artikel
		GROUP BY a.pKey, u.pKey
		ORDER BY Anzahl DESC
		LIMIT $limit
		) m ORDER BY Anzahl DESC
	";
	$r=mysql_query($q) or die(mysql_error());
	$namen   = array();
	$werte   = array();
	$wleer   = array();
	if (mysql_num_rows($r) == 0) { $imax = 10; } else { $imax = mysql_num_rows($r); }
	
	
	$i=0;
	while ( $i<$imax) {
		$i++;
		if ($z=mysql_fetch_array($r)) {
			//array_push($namen, trim(utf8_decode(stripslashes($z["Familienname"] .", ". $z["Vorname"]))).chr(10).' ');
			array_push($namen, trim(stripslashes($z["Familienname"] .", ". $z["Vorname"])).chr(10).' ');
			array_push($werte, $z["Anzahl"]+0);
			array_push($wleer, 0);
		} else {
			array_push($namen, ' '.chr(10).' ');
			array_push($werte, 0);
			array_push($wleer, 0);
		}
		unset($z);
	}

	$r=mysql_query("SELECT Bild, Name FROM artikel WHERE pKey=$artikel");
	$z=mysql_fetch_row($r);
	$bildString = $z[0];
	$aName      = trim(utf8_decode(stripslashes($z[1])));

	$minMaxSteps = 4;
	$max   = floor(max($werte)*1.2);
	if ($max - max($werte) < $minMaxSteps) {
		$max += $minMaxSteps - ($max - max($werte));
	}

	
	// Dieses Script wird die jeweiligen Bargraphen zeichnen.
	require_once ("jpgraph/jpgraph.php");
	require_once ("jpgraph/jpgraph_line.php");
	require_once ("jpgraph/jpgraph_bar.php");
	require_once ("jpgraph/jpgraph_iconplot.php");
	require_once ("jpgraph/jpgraph_text.inc.php");
	require_once ("jpgraph/jpgraph_log.php");
 
	 // Width and height of the graph
	$gDateLocale = new DateLocale();
	$gDateLocale->Set("");
	$mon = $gDateLocale->GetLongMonthName($monat-1); 
	
	$width = (count($namen)*40)+60;
	$height = 250;
 
	// Create the graph.
	$graph = new Graph($width,$height);
	$graph->SetScale('textlin',0,$max,0,0);
	$graph->SetMarginColor('white');
 
	// Setup title
	$graph->title->Set("$aName - $mon $jahr");
	
	//Beschriftungen
	$graph->xaxis->SetFont(FF_ARIAL, FS_NORMAL, 7.5);
	$graph->xaxis->SetColor('black','darkblue');
	$graph->xaxis->SetLabelMargin(-5); 
	$graph->xaxis->SetLabelAngle(90); //45 degrees angle
	$graph->xaxis->SetLabelAlign('center','bottom');
	$graph->xaxis->SetTickLabels($namen); 

	// Create the first bar
	$bplot = new BarPlot($werte);
	$bplot->SetFillGradient('AntiqueWhite2','AntiqueWhite4:0.8',GRAD_VERT);
	$bplot->SetWidth(12);
	$bplot->SetColor('darkred');
	$bplot->SetAlign("center"); 

	$bplot->value->Show();
	$bplot->value->SetFont(FF_ARIAL,FS_NORMAL,10);
	$bplot->value->SetColor('black','darkred');
	$bplot->value->SetFormat('%1u');

	$bplot2 = new BarPlot($wleer);
	$gPlot = new GroupBarPlot(array($bplot2, $bplot));

	$tMargin  = 20;
	$bMargin  = 20;
	$hDiagram = $height - $tMargin - $bMargin;
	
	//Hintergrundbild einfgen
	if ($bildString) {
		$icon = new IconPlot();
		
		$icon->CreateFromString($bildString);
		$dim = $icon->GetWidthHeight();
		$iWidth  = $dim[0];
		$iHeight = $dim[1];
		$verhaeltnis = (float)$height / (float)$width;
		$iVerhaeltnis = (float)$iHeight / (float)$iWidth;

		//if ($iVerhaeltnis > 1) {
			// Artikel-Bild im Hochformat
			$scale = $width / $iWidth;# * 0.8;
		//} else {
			// Artikel-Bild im Querformat
		//	$scale = $height / $iHeight * ;
		//}
		$icon->SetPos(0.5,0.5);
		if ($iVerhaeltnis > 1) {
			$icon->SetPos(0.5,0.0);
		}

		$icon->SetScale($scale);
		$icon->SetMix(20);
		$icon->SetAnchor('center','center');
		$graph->Add($icon);
	}
	
	$graph->Add($gPlot);
	
	$graph->SetMargin(40,20,$tMargin,$bMargin);
	header('Content-Type: image/png');
	$graph->Stroke();
?>